config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.snort.new
config etc/snort/snort.conf.new
config etc/snort/reference.config.new
config etc/snort/threshold.conf.new
config etc/snort/attribute_table.dtd.new
config etc/snort/classification.config.new
config etc/snort/gen-msg.map.new
config etc/snort/unicode.map.new

( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_smtp_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_smtp_preproc.so.0.0.0 libsf_smtp_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_imap_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_imap_preproc.so.0.0.0 libsf_imap_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_pop_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_pop_preproc.so.0.0.0 libsf_pop_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_dns_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_dns_preproc.so.0.0.0 libsf_dns_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_dnp3_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_dnp3_preproc.so.0.0.0 libsf_dnp3_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_gtp_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_gtp_preproc.so.0.0.0 libsf_gtp_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_ssl_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_ssl_preproc.so.0.0.0 libsf_ssl_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_reputation_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_reputation_preproc.so.0.0.0 libsf_reputation_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_dce2_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_dce2_preproc.so.0.0.0 libsf_dce2_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_dce2_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_dce2_preproc.so.0.0.0 libsf_dce2_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_gtp_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_gtp_preproc.so.0.0.0 libsf_gtp_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_sip_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_sip_preproc.so.0.0.0 libsf_sip_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_ssl_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_ssl_preproc.so.0.0.0 libsf_ssl_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_sdf_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_sdf_preproc.so.0.0.0 libsf_sdf_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_imap_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_imap_preproc.so.0.0.0 libsf_imap_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_ftptelnet_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_ftptelnet_preproc.so.0.0.0 libsf_ftptelnet_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_reputation_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_reputation_preproc.so.0.0.0 libsf_reputation_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_modbus_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_modbus_preproc.so.0.0.0 libsf_modbus_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_pop_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_pop_preproc.so.0.0.0 libsf_pop_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_ssh_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_ssh_preproc.so.0.0.0 libsf_ssh_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_sdf_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_sdf_preproc.so.0.0.0 libsf_sdf_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_ftptelnet_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_ftptelnet_preproc.so.0.0.0 libsf_ftptelnet_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_dns_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_dns_preproc.so.0.0.0 libsf_dns_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_smtp_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_smtp_preproc.so.0.0.0 libsf_smtp_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_modbus_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_modbus_preproc.so.0.0.0 libsf_modbus_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_ssh_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_ssh_preproc.so.0.0.0 libsf_ssh_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_sip_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_sip_preproc.so.0.0.0 libsf_sip_preproc.so.0 )
( cd usr/lib/snort_dynamicpreprocessor ; rm -rf libsf_dnp3_preproc.so )
( cd usr/lib/snort_dynamicpreprocessor ; ln -sf libsf_dnp3_preproc.so.0.0.0 libsf_dnp3_preproc.so )
( cd usr/lib/snort_dynamicengine ; rm -rf libsf_engine.so.0 )
( cd usr/lib/snort_dynamicengine ; ln -sf libsf_engine.so.0.0.0 libsf_engine.so.0 )
( cd usr/lib/snort_dynamicengine ; rm -rf libsf_engine.so )
( cd usr/lib/snort_dynamicengine ; ln -sf libsf_engine.so.0.0.0 libsf_engine.so )
